class CPlayer extends MovieClip
{
   var x;
   var y;
   var state;
   var shotTimeCounter;
   var torpedoTimeCounter;
   var acc;
   var maxSpeed;
   var downAcc;
   var curSpeed;
   var dir;
   var mouseControl;
   var xRad;
   var yRad;
   var migFlag;
   var mc;
   var shotFlag;
   var mouseInactiveRadius = 35;
   static var SHOT_DELAY = 350;
   static var TORPEDO_DELAY = 1200;
   function CPlayer()
   {
      super();
      this.x = this.y = 0;
      this.state = 0;
      this.shotTimeCounter = CPlayer.SHOT_DELAY;
      this.torpedoTimeCounter = CPlayer.TORPEDO_DELAY;
      this.stop();
   }
   function init(acc_, maxSpeed_, downAcc_)
   {
      this.acc = acc_;
      this.maxSpeed = maxSpeed_;
      this.downAcc = downAcc_;
      this.curSpeed = 0;
      this.dir = new CVector2D(1,0);
      this.mouseControl = false;
      this.xRad = this._width / 2;
      this.yRad = this._height / 2;
      this.migFlag = false;
   }
   function toFly()
   {
      this.state = 1;
   }
   function process(dTime)
   {
      var _loc7_ = undefined;
      var _loc6_ = undefined;
      var _loc4_ = undefined;
      var _loc5_ = undefined;
      this.shotTimeCounter += dTime;
      this.torpedoTimeCounter += dTime;
      dTime /= 1000;
      if(this.state == 1)
      {
         _loc7_ = Key.isDown(37);
         _loc5_ = Key.isDown(39);
         _loc6_ = Key.isDown(38);
         _loc4_ = Key.isDown(40);
         if(_loc7_ || _loc5_ || _loc6_ || _loc4_)
         {
            this.mouseControl = false;
         }
         var _loc2_ = new CVector2D(0,0);
         var _loc8_ = undefined;
         if(this.mouseControl)
         {
            _loc2_.reinit(this._parent._xmouse - this._x,this._parent._ymouse - this._y);
            _loc8_ = _loc2_.modul();
            if(_loc8_ > this.mouseInactiveRadius)
            {
               _loc2_.normalize();
               this.updateView(_loc2_);
               _loc2_.mult(this.acc);
            }
            else
            {
               _loc2_.reinit(0,0);
               this.mc.gotoAndStop("st_");
            }
         }
         else
         {
            if(_loc7_)
            {
               _loc2_.x -= 1;
            }
            if(_loc5_)
            {
               _loc2_.x += 1;
            }
            if(_loc6_)
            {
               _loc2_.y -= 1;
            }
            if(_loc4_)
            {
               _loc2_.y += 1;
            }
            _loc2_.normalize();
            if(_loc2_.modul() > 0.001)
            {
               this.updateView(_loc2_);
            }
            else
            {
               this.mc.gotoAndStop("st_");
            }
            _loc2_.mult(this.acc);
         }
         this.curSpeed -= this.downAcc * dTime * dTime;
         if(this.curSpeed < 0)
         {
            this.curSpeed = 0;
         }
         this.dir.mult(this.curSpeed);
         _loc2_.mult(dTime * dTime);
         this.dir.plus(_loc2_);
         this.curSpeed = this.dir.modul();
         if(this.curSpeed > this.maxSpeed)
         {
            this.curSpeed = this.maxSpeed;
         }
         this.dir.normalize();
         this.x += this.dir.x * this.curSpeed;
         this.y += this.dir.y * this.curSpeed;
      }
      else if(this.state == 3)
      {
         this.y += this.maxSpeed * 7 * dTime;
         this._rotation += 500 * dTime;
      }
   }
   function updateView(addSpeed)
   {
      var _loc2_ = "st_";
      if(addSpeed.y > 0.3)
      {
         _loc2_ += "d";
      }
      else if(addSpeed.y < -0.3)
      {
         _loc2_ += "u";
      }
      if(addSpeed.x > 0.3)
      {
         _loc2_ += "r";
      }
      else if(addSpeed.x < -0.3)
      {
         _loc2_ += "l";
      }
      this.mc.gotoAndStop(_loc2_);
   }
   function screenSynchronize(objTransform)
   {
      var _loc2_ = {x:this.x,y:this.y,k:0};
      objTransform.getScreenXY(this.x,this.y,0,_loc2_);
      this._x = _loc2_.x;
      this._y = _loc2_.y;
      if(this.state == 3 && this.y > objTransform.nearHeight * 2)
      {
         this.toOver();
      }
   }
   function myMouseMove()
   {
      this.mouseControl = true;
   }
   function tryShot()
   {
      if(this.shotTimeCounter >= CPlayer.SHOT_DELAY)
      {
         this.shotFlag = true;
         this.shotTimeCounter = 0;
      }
   }
   function isShot()
   {
      if(this.shotFlag)
      {
         this.shotFlag = false;
         return true;
      }
      return false;
   }
   function canTorpedo()
   {
      return this.torpedoTimeCounter >= CPlayer.TORPEDO_DELAY;
   }
   function doTorpedo()
   {
      this.torpedoTimeCounter = 0;
   }
   function toMig()
   {
      this.migFlag = true;
      this.gotoAndPlay(2);
   }
   function toFall()
   {
      this.gotoAndStop(1);
      this.mc.gotoAndStop("st_");
      this.migFlag = true;
      this.state = 3;
   }
   function isFall()
   {
      return this.state == 3;
   }
   function toOver()
   {
      this.state = 4;
      this._visible = false;
   }
   function isOver()
   {
      return this.state == 4;
   }
   function endMig()
   {
      this.migFlag = false;
      this.gotoAndStop(1);
   }
   function disable()
   {
      this._visible = false;
      this.state = 5;
   }
}
